Release new version 0.10.0
[grml-autoconfig.git] / autoconfig.functions
index 0f7b228..69075bf 100755 (executable)
@@ -7,7 +7,7 @@
 ################################################################################
 
 # {{{ path, variables, signals, umask, zsh
-export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
+export PATH="/bin:/sbin:/usr/bin:/usr/sbin"
 DEBUG="/dev/null"
 KERNEL="$(uname -r)"
 ARCH="$(uname -m)"
@@ -15,8 +15,10 @@ umask 022
 
 # old linuxrc version:
 [ -d /cdrom ]      && export LIVECD_PATH=/cdrom
-# new initramfs layout:
+# initramfs layout until around December 2012:
 [ -d /live/image ] && export LIVECD_PATH=/live/image
+# initramfs layout since around December 2012:
+[ -d /lib/live/mount/medium ] && export LIVECD_PATH=/lib/live/mount/medium
 
 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
 [ -z "$PS1" ] && trap "" 2 3 11
@@ -38,8 +40,18 @@ if [ -z "$CMDLINE" ]; then
   # if CMDLINE was set from the outside, we're debugging.
   # otherwise, take CMDLINE from Kernel and config files.
   CMDLINE="$(cat /proc/cmdline)"
-  [ -d /cdrom/bootparams/ ]      && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
-  [ -d /live/image/bootparams/ ] && CMDLINE="$CMDLINE $(cat /live/image/bootparams/* | tr '\n' ' ')"
+  [ -d ${LIVECD_PATH}/bootparams/ ] && CMDLINE="$CMDLINE $(cat ${LIVECD_PATH}/bootparams/* | tr '\n' ' ')"
+  modprobe 9p 2>/dev/null || true
+  if grep -q 9p /proc/filesystems ; then
+      TAG="grml-parameters"
+      if grep -q "$TAG" /sys/bus/virtio/devices/*/mount_tag 2>/dev/null ; then
+          MOUNTDIR="$(mktemp -d)"
+          mount -t 9p -o trans=virtio,ro "$TAG" "$MOUNTDIR"
+          CMDLINE="$CMDLINE $(cat "$MOUNTDIR"/* 2>/dev/null | tr '\n' ' ')"
+          umount "$MOUNTDIR"
+          rmdir "$MOUNTDIR"
+      fi
+  fi
 fi
 # }}}
 
@@ -117,10 +129,23 @@ mount_sys(){
 # {{{ Check if we are running in live mode or from HD
 INSTALLED=""
 [ -e /etc/grml_cd ] || INSTALLED="yes"
+# }}}
 
-# testcd
-TESTCD=""
-checkbootparam 'testcd' >>$DEBUG 2>&1 && TESTCD="yes"
+# {{{ provide information about virtual environments
+VIRTUAL=false # assume physical system by default
+KVM=false
+VIRTUALBOX=false
+VMWARE=false
+
+if vmware-detect &>/dev/null; then
+  VIRTUAL=true; VMWARE=true; VIRTUAL_ENV='VMware'
+elif [ "$(virt-what 2>/dev/null)" = "kvm" ] || \
+   [ "$(imvirt 2>/dev/null)" = "KVM" ] ; then
+  VIRTUAL=true; KVM=true; VIRTUAL_ENV='KVM'
+elif [ "$(virt-what 2>/dev/null)" = "virtualbox" ] || \
+   [ "$(imvirt 2>/dev/null)" = "VirtualBox" ] ; then
+  VIRTUAL=true; VIRTUALBOX=true; VIRTUAL_ENV='VirtualBox'
+fi
 # }}}
 
 # {{{ source lsb-functions , color handling
@@ -193,7 +218,7 @@ config_fwtimeout(){
  fi
  if [ -f /sys/class/firmware/timeout ] ; then
    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
-   echo 100 > /sys/class/firmware/timeout ; eend $?
+   echo $TIMEOUT > /sys/class/firmware/timeout ; eend $?
  fi
 }
 # }}}
@@ -219,10 +244,10 @@ config_language(){
  if [ -x /usr/sbin/grml-setlang ] ; then
    # if bootoption lang is used update /etc/default/locale accordingly
    if [ -n "$BOOT_LANGUAGE" ] ; then
-     checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "$LANGUAGE"
+     /usr/sbin/grml-setlang "$LANGUAGE"
    # otherwise default to lang=en
    else
-     checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "en"
+     /usr/sbin/grml-setlang "en"
    fi
  fi
 
@@ -241,12 +266,8 @@ config_language(){
  fi
 
  # export it now, so error messages get translated, too
- if checkgrmlsmall ; then
-    export LANG='C' # grml-small does not provide any further locales
- else
-    [ -r /etc/default/locale ] && . /etc/default/locale
-    export LANG LANGUAGE
- fi
+ [ -r /etc/default/locale ] && . /etc/default/locale
+ export LANG LANGUAGE
 
  # configure keyboard layout, read in already set values first:
  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
@@ -369,33 +390,74 @@ config_language(){
 
 # {{{ Set hostname
 config_hostname(){
- if checkbootparam 'hostname' ; then
+  if ! checkbootparam 'hostname' ; then
+    return 0
+  fi
+
   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
   if [ -z "$HOSTNAME" ] && [ -x /usr/bin/random-hostname ] ; then
-     einfo "Generating random hostname as no hostname was specified."
-     HOSTNAME="$(/usr/bin/random-hostname)"
-     eend $?
+    einfo "Generating random hostname as no hostname was specified."
+    HOSTNAME="$(/usr/bin/random-hostname)"
+    eend $?
   fi
+
   einfo "Setting hostname to $HOSTNAME as requested."
-  grml-hostname $HOSTNAME >>$DEBUG ; RC=$?
-  [ "$RC" = "0" ] && hostname $HOSTNAME
-  eend $RC
- else
-  hostname --file /etc/hostname
- fi
+  grml-hostname $HOSTNAME >>$DEBUG
+  eend $?
 }
 # }}}
 
 # fstabuser (needed when running from harddisk with username != grml {{{
 config_userfstab(){
+  # force load of build-in and local config
   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
+  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig.local
+
+  # 1st. try configured fstab user
   if [ -n "$CONFIG_FSTAB_USER" ] ; then
-     fstabuser="$CONFIG_FSTAB_USER"
+     fstabuser=$(getent passwd $CONFIG_FSTAB_USER | cut -d: -f1)
+  fi
+
+  # 2nd. use standard user id
+  [ -n "$fstabuser" ] || fstabuser=$(getent passwd 1000 | cut -d: -f1)
+
+  # 3rd. use standard user name
+  [ -n "$fstabuser" ] || fstabuser=$(getent passwd grml | cut -d: -f1)
+
+  # if not yet set fall back to 'root' user, avoid bad /etc/fstab
+  [ -n "$fstabuser" ] || fstabuser='root'
+}
+# }}}
+
+# local_user (needed when running with username != grml {{{
+config_userlocal() {
+
+  # force load of build-in and local config
+  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
+  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig.local
+
+  # 1st. try id of primary user
+  localuser=$(getent passwd 1000 | cut -d: -f1)
+
+  # 2nd. use name standard user
+  [ -n "$localuser" ] || localuser=$(getent passwd grml | cut -d: -f1)
+}
+# }}}
+
+# {{{ mount configfs
+config_configfs() {
+  einfo "Mounting configfs"
+  CONFIGFS_DIR=/sys/kernel/config/
+  modprobe configfs 2>/dev/null 1>&2
+  if ! [  -d "$CONFIGFS_DIR" ] ; then
+    eindent
+    einfo "$CONFIGFS_DIR does not exist, can't mount directory"
+    eend 1
+    eoutdent
   else
-     fstabuser=$(getent passwd 1000 | cut -d: -f1)
+    mount -t configfs configfs "$CONFIGFS_DIR" 2>/dev/null 1>&2
+    eend $?
   fi
-  # if not yet set fall back to default 'grml' user
-  [ -n "$fstabuser" ] || fstabuser='grml'
 }
 # }}}
 
@@ -439,20 +501,24 @@ config_time(){
 
 # {{{ print kernel info
 config_kernel(){
-  vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
-  [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
-  einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
+  if $VIRTUAL && [ -n "$VIRTUAL_ENV" ] ; then
+    einfo "Running Linux Kernel $KERNEL inside $VIRTUAL_ENV" ; eend 0
+  else
+    einfo "Running Linux Kernel $KERNEL" ; eend 0
+  fi
+
   if [ -r /proc/cpuinfo ] ; then
-     if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
-       eindent
-       einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
-       eoutdent
-     fi
+    if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
+      eindent
+      einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
+      eoutdent
+    fi
   fi
+
   if [ -d /proc/xen ] ; then
-     eindent
-     einfo 'Running kernel featuring support for Xen detected' ; eend 0
-     eoutdent
+    eindent
+    einfo 'Running kernel featuring support for Xen detected' ; eend 0
+    eoutdent
   fi
 }
 # }}}
@@ -551,7 +617,7 @@ eoutdent
 config_fast(){
 if checkbootparam 'fast'; then
   ewarn "Bootoption fast detected. Skipping startup of grml-quickconfig."
-    sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
+    sed -i '/1:/s#/usr/share/grml-scripts/run-welcome#/bin/zsh#' /etc/inittab
   /sbin/telinit q ; eend $?
 fi
 }
@@ -613,18 +679,6 @@ fi
 }
 # }}}
 
-# {{{ Bring up loopback interface now
-config_local_net(){
- if [ -z "$INSTALLED" ] ; then
-    if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
-       grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
-    else
-       ifconfig lo up
-    fi
- fi
-}
-# }}}
-
 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
 # otherwise we will get: passwd: Authentication token lock busy
 config_fix_passwd(){
@@ -636,29 +690,45 @@ config_fix_passwd(){
 
 # {{{ CD Checker
 config_testcd(){
-if [ -n "$TESTCD" ]; then
-   einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
-   einfo "Reading files and checking against GRML/md5sums, this may take a while..."
-   echo -n "${RED}"
+if checkbootparam 'testcd' ; then
+  einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
+  eindent
 
-   if [ -n "${LIVECD_PATH}"/GRML ] ; then
-      ( cd "${LIVECD_PATH}"/GRML ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log ; RC=$? )
-   else
-      echo "${RED} *** Error: Could not find md5sum file.                           ***"
-   fi
+  local ERROR=true
+  local FOUND_FILE=false
+  local logfile='/tmp/md5sum.log'
 
-   if [ "$RC" = "0" ]; then
-      einfo "Everything looks OK" ; eend 0
-   else
-      eerror 'Checksum failed for theses files:' ; eend 1
-      egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
-      eerror 'Data on the grml medium is possibly incomplete/damaged or...'
-      eerror '... RAM of your computer is broken.' ; eend 1
-      einfon "Hit return to continue, or press the reset button to quit."
-     read a
-   fi
+  rm -f "$logfile"
 
-   eend 0
+  for md5 in $(find "${LIVECD_PATH}" -name md5sums) ; do
+    einfo "Checking files against $md5, this may take a while..."
+
+    FOUND_FILE=true
+    OLD_PWD=$(pwd)
+    cd $(dirname "$md5")
+    md5sum -c $(basename "$md5") |& tee -a "${logfile}"
+    if [ $pipestatus[1] -eq 0 ] ; then
+      ERROR=false
+    fi
+    cd "${OLD_PWD}"
+  done
+
+  if ! $FOUND_FILE ; then
+    eerror 'Error: Could not find md5sum file' ; eend 1
+    return
+  fi
+
+  if ! $ERROR ; then
+    einfo "Everything looks OK" ; eend 0
+  else
+    eerror 'Checksum failed for theses files:' ; eend 1
+    egrep -v '(^md5sum:|OK$)' "${logfile}"
+    eerror 'Data on the medium is possibly incomplete/damaged or RAM of your system is broken.' ; eend 1
+    einfon "Hit return to continue, or press the power button to shut down system."
+    read a
+  fi
+
+  eoutdent
 fi
 }
 # }}}
@@ -697,6 +767,8 @@ if checkbootparam 'noacpi'; then
   ewarn "ACPI: Not loading modules as requested by boot option \"noacpi\"." ; eend 0
 elif checkbootparam 'nogrmlacpi' ; then
   ewarn "ACPI: Not loading modules as requested by boot option \"nogrmlacpi\"." ; eend 0
+elif [ ! -d /proc/acpi ] ; then
+  ewarn "ACPI: Kernel support not present." ; eend 0
 else
   einfo "ACPI: Loading modules (disable with boot option noacpi / nogrmlacpi): "
   eindent
@@ -715,7 +787,7 @@ else
   else
     ewarn "(none)" ; eend 1
   fi
-  if ! ps x 2>>$DEBUG | grep -q /usr/sbin/acpid ; then
+  if ! pgrep acpid >/dev/null ; then
     einfo "Starting acpi daemon."
     /etc/init.d/acpid start >>$DEBUG 2>&1 ; eend $?
   else
@@ -747,6 +819,14 @@ EOT
 check_partitions >/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
 # }}}
 
+# {{{ Start brltty
+config_brltty() {
+  if checkbootparam 'brltty' ; then
+    [ -x /lib/brltty/brltty.sh ] && /lib/brltty/brltty.sh
+  fi
+}
+# }}}
+
 # {{{ Enable DMA for all IDE drives now if not disabled
 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
 config_dma(){
@@ -926,16 +1006,16 @@ if checkbootparam 'nocpu'; then
 fi
 
 if [[ $(grep -c processor /proc/cpuinfo) -gt 1 ]] ; then
-   einfo "Detecting CPU:"
+   einfo "Found CPU:"
    CPU=$(awk -F: '/^processor/{printf "        Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
    echo $CPU | sed 's/ \{1,\}/ /g'
    eend 0
 else
-   einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
+   einfo "Found CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
 fi
 
 # no cpufreq setup inside VirtualBox
-if [ -r /proc/acpi/battery/BAT0/info ] && grep -q 'OEM info:.*innotek' /proc/acpi/battery/BAT0/info ; then
+if $VIRTUALBOX ; then
    einfo 'Virtual Box detected, skipping cpufreq setup.' ; eend 0
    return 0
 fi
@@ -962,6 +1042,7 @@ if [ -x /etc/init.d/loadcpufreq ] ; then
       if [ -n "$MODULE" -a "$MODULE" != none ]; then
          einfo "Loading cpufreq kernel module $MODULE" ; eend 0
       else
+         SKIP_CPU_GOVERNOR=1
          ewarn "Could not find an appropriate kernel module for cpu frequency scaling." ; eend 1
       fi
    fi
@@ -969,14 +1050,18 @@ if [ -x /etc/init.d/loadcpufreq ] ; then
    rm -f $LOADCPUFREQ
 
    if [ -z "$SKIP_CPU_GOVERNOR" ] ; then
-      einfo "Loading cpufreq_ondemand, setting ondemand governor"
-      RC=0
-      if modprobe cpufreq_ondemand ; RC=$? ; then
-         for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
-            echo ondemand > $file
-         done
-      fi
-      eend $RC
+     if grep -vq ondemand /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_governors; then
+       einfo "Loading cpufreq_ondemand"
+       modprobe cpufreq_ondemand
+       eend $?
+     fi
+
+     einfo "Setting ondemand governor"
+     RC=0
+     for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
+       echo ondemand > $file || RC=1
+     done
+     eend $RC
    fi # cpu-governor
 
    eoutdent
@@ -989,7 +1074,9 @@ config_ssh(){
 if checkbootparam 'ssh' ; then
    SSH_PASSWD=''
    SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
-   einfo "Bootoption ssh found, trying to set password for user grml."
+   config_userlocal
+   einfo "Bootoption ssh found, trying to set password for root and user $localuser"
+   [ -z "$localuser" ] && eend 1
    eindent
    if [ -z "$SSH_PASSWD" ] ; then
       if [ -x /usr/bin/apg ] ; then
@@ -1017,33 +1104,49 @@ if checkbootparam 'ssh' ; then
    # finally check if we have a password we can use:
    if [ -n "$SSH_PASSWD" ] ; then
       # chpasswd sucks, seriously.
+      chpass_options=""
       if chpasswd --help 2>&1 | grep -q -- '-m,' ; then
-        echo "grml:$SSH_PASSWD" | chpasswd -m
-      else
-        echo "grml:$SSH_PASSWD" | chpasswd
+        chpass_options="-m"
       fi
+      echo "$localuser:$SSH_PASSWD" | chpasswd $chpass_options
+      echo "root:$SSH_PASSWD" | chpasswd $chpass_options
    fi
 
-   einfo 'Starting secure shell server in background.'
+   einfo "Starting secure shell server in background for root and user $localuser"
    /etc/init.d/rmnologin start >>$DEBUG 2>>$DEBUG
    /etc/init.d/ssh start >>$DEBUG 2>>$DEBUG &
    eend $?
 
    eindent
-   ewarn 'Warning: please change the password for user grml as soon as possible!'
+   ewarn "Warning: please change the password for root and user $localuser as soon as possible!"
    eoutdent
 fi
 }
+
+# }}}
+
+# {{{ display hostkeys of SSH server
+config_display_ssh_fingerprints() {
+  if ! ls /etc/ssh/ssh_host_\*_key >/dev/null 2>&1 ; then
+    return 0 # no SSH host keys present
+  fi
+
+  einfo "SSH key fingerprints:"
+  for file in /etc/ssh/ssh_host_*_key ; do
+    einfon
+    ssh-keygen -l -f $file
+  done | column -t
+  eend $?
+}
 # }}}
 
 # {{{ autostart of x11vnc
 config_vnc(){
-
-USER=grml # TODO: make it dynamically configurable
 if checkbootparam 'vnc' ; then
+   config_userlocal
    VNC_PASSWD=''
    VNC_PASSWD="$(getbootparam 'vnc' 2>>$DEBUG)"
-   einfo "Bootoption vnc found, trying to set password for user $USER."
+   einfo "Bootoption vnc found, trying to set password for user $localuser."
    eindent
    if [ -z "$VNC_PASSWD" ] ; then
       if [ -x /usr/bin/apg ] ; then
@@ -1055,7 +1158,7 @@ if checkbootparam 'vnc' ; then
       elif [ -x /usr/bin/hexdump ] ; then
          VNC_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
       elif [ -n "$RANDOM" ] ; then
-         VNC_PASSWD="${USER}${RANDOM}"
+         VNC_PASSWD="${localuser}${RANDOM}"
       else
          VNC_PASSWD=''
          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
@@ -1071,7 +1174,7 @@ if checkbootparam 'vnc' ; then
    # finally check if we have a password we can use:
    if [ -n "$VNC_PASSWD" ] ; then
 
-      VNCDIR="/home/${USER}/.vnc"
+      VNCDIR="/home/${localuser}/.vnc"
       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
 
       if [ ! -x /usr/bin/x11vnc ] ; then
@@ -1079,7 +1182,7 @@ if checkbootparam 'vnc' ; then
          eend 1
       else
          /usr/bin/x11vnc -storepasswd "$VNC_PASSWD" "$VNCDIR"/passwd ; eend $?
-         /bin/chown -R "$USER": "$VNCDIR"
+         /bin/chown -R "$localuser": "$VNCDIR"
       fi
    fi
    if checkbootparam 'vnc_connect' ; then
@@ -1087,7 +1190,7 @@ if checkbootparam 'vnc' ; then
       VNC_CONNECT="$(getbootparam 'vnc_connect' 2>>$DEBUG)"
       einfo "Bootoption vnc_connect found, will start vnc with connect to $VNC_CONNECT."
       #store the options in a file
-      VNCDIR="/home/${USER}/.vnc"
+      VNCDIR="/home/${localuser}/.vnc"
       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
       echo " --connect $VNC_CONNECT " >> $VNCDIR/options
    fi
@@ -1095,13 +1198,15 @@ fi
 }
 # }}}
 
-# {{{ set password for user grml
+# {{{ set password for default user
 config_passwd(){
 if checkbootparam 'passwd' >>$DEBUG 2>&1; then
-  einfo "Bootoption passwd found."
   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
+  config_userlocal
+  einfo "Bootoption passwd found, change password for user '$localuser'."
+  [ -z "$localuser" ] && eend 1
   if [ -n "$PASSWD" ] ; then
-    echo "grml:$PASSWD" | chpasswd -m ; eend $?
+    echo "$localuser:$PASSWD" | chpasswd -m ; eend $?
   else
     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
   fi
@@ -1154,22 +1259,36 @@ config_mixer () {
 
             if checkbootparam 'micvol' ; then
                MICVOL="$(getbootparam 'micvol' 2>>$DEBUG)"
+               einfo "Setting microphone to ${WHITE}${MICVOL}${NORMAL}."
             else
                MICVOL=0
             fi
 
-            for CONTROL in Master PCM ; do
-               if amixer -q | grep -q "Simple mixer control '$CONTROL'" ; then
-                  amixer -q set "${CONTROL}" "${VOL}"%
+            CONTROLS=$(amixer -c $card scontrols | awk -F"Simple mixer control " '{print $2}')
+            IFSOLD=${IFS:-}
+            IFS='
+'
+            for CONTROL in ${=CONTROLS} ; do
+               if ! echo "${CONTROL}" | grep -q -i "mic" ; then
+                   if amixer -c $card sget "${CONTROL}" | grep -q 'Capabilities:.*pswitch' ; then
+                      amixer -c $card -q set "${CONTROL}" unmute
+                   fi
+                   if amixer -c $card sget "${CONTROL}" | grep -q -P 'Capabilities:.*(pvolume| volume)' ; then
+                      amixer -c $card -q set "${CONTROL}" "${VOL}"%
+                   fi
+               fi
+
+               if [ ${MICVOL} -ne 0 ] ; then
+                  if amixer -c $card sget "${CONTROL}" | grep -q 'Capabilities:.*cswitch' ; then
+                     amixer -c $card -q set "${CONTROL}" unmute
+                  fi
+                  if amixer -c $card sget "${CONTROL}" | grep -q 'Capabilities:.*cvolume' ; then
+                     amixer -c $card -q set "${CONTROL}" $MICVOL%
+                  fi
                   eend $?
                fi
             done
-
-            if [ ${MICVOL} -ne 0 ] ; then
-               einfo "Setting microphone to ${WHITE}${MICVOL}${NORMAL}."
-               amixer -q set "Mic" $MICVOL &> /dev/null
-               eend $?
-            fi
+            IFS=$IFSOLD
          fi # checkbootparam 'nosound'
          eoutdent
       done
@@ -1343,6 +1462,35 @@ config_netscript() {
 }
 # }}}
 
+# {{{ stats
+config_stats() {
+ if ! checkbootparam 'nostats' ; then
+   BASE_URL="http://stats.grml.org/report/"
+   ACTION_NAME=Boot
+
+   HOST_ID=$(cat /proc/sys/kernel/random/boot_id)
+
+   grep -q " lm " /proc/cpuinfo && HAS_64BIT="1" || HAS_64BIT="0"
+   DATE_STRING=$(date +'h=%H&m=%M&s=%S')
+   [ -e /etc/grml_version ] && VERSION=$(cat /etc/grml_version) || \
+     VERSION=$(lsb_release -d | awk -F: '{gsub(/^[ \t]+/, "", $2); print $2}')
+
+   PARAMS="$( echo "$CMDLINE" | sed -e 's/=[^ ]*/=x/g' | tr " " "\n"|sort|tr "\n" " " )"
+
+   echo "$CMDLINE" | grep -q -e "fetch" -e "nfsroot" && BOOT="remote"
+   [ -z "$BOOT" ] && BOOT="local"
+
+   ADDITIONAL_PARAMS=""
+   ( [ -n "$COLUMNS" ] && [ -n "$LINES" ] ) && \
+     ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS&res=$((COLUMNS * 8))x$((LINES * 16))"
+
+   URI='$BASE_URL?action=${ACTION_NAME}\&$DATE_STRING\&unique_id=${HOST_ID}\&support_64bit=$HAS_64BIT\&version=$VERSION\&bootup=$BOOT\&params=$PARAMS$ADDITIONAL_PARAMS'
+
+   get_remote_file "$URI" "/dev/null"  >/dev/null 2>&1 &!
+ fi
+}
+# }}}
+
 # {{{ fix/workaround for unionfs
 fix_unionfs(){
   if [ -z "$INSTALLED" ]; then
@@ -1360,16 +1508,15 @@ if checkbootparam 'startx' && ! echo "$CMDLINE" | grep -q 'startx.*nostartx' ; t
   if [ -z "$INSTALLED" ] ; then
    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
    if [ -z "$WINDOWMANAGER" ] ; then
-     einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
-     WINDOWMANAGER="wm-ng"
+     einfo "No window manager specified. Using default one." && eend 0
    else
      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
    fi
    einfo "Setting up and invoking grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
-   config_userfstab || fstabuser='grml'
+   config_userlocal
  cat>|/etc/init.d/xstartup<<EOF
 #!/bin/sh
-su $fstabuser -c "/usr/bin/grml-x $WINDOWMANAGER"
+su $localuser -c "/usr/bin/grml-x ${WINDOWMANAGER}"
 EOF
    chmod 755 /etc/init.d/xstartup
 
@@ -1393,7 +1540,7 @@ EOF
     eerror " -> Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
   fi
  else
-   eerror "/usr/X11R6/bin/X is not present on this grml flavour."
+   eerror "/usr/bin/X is not present on this grml flavour."
    eerror "  -> Boot parameter startx does not work therefore." ; eend 1
  fi
 fi
@@ -1424,6 +1571,7 @@ DCSMP="/mnt/grml"
 GRMLCFG="$(getbootparam 'autoconfig' 2>>$DEBUG)"
 [ -n "$GRMLCFG" ] || GRMLCFG="GRMLCFG"
 if checkbootparam 'noautoconfig' || checkbootparam 'forensic' ; then
+  DCSDIR="${LIVECD_PATH}" # set default so it works for "scripts" boot option as expected
   ewarn "Skipping running automount of device(s) labeled $GRMLCFG as requested." ; eend 0
 else
   if [ -z "$INSTALLED" ] ; then
@@ -1443,6 +1591,17 @@ else
         fi
       fi
       DCSDEVICE=$(blkid -t LABEL=$GRMLCFG | head -1 | awk -F: '{print $1}')
+
+      modprobe 9p 2>/dev/null || true
+      if [ -z "$DCSDEVICE" ] && grep -q 9p /proc/filesystems ; then
+          if grep -q "$GRMLCFG" /sys/bus/virtio/devices/*/mount_tag 2>/dev/null ; then
+            einfo "Found 9p-virtio fs with mount_tag $GRMLCFG"
+            DCSDEVICE="$GRMLCFG"
+            MOUNTOPTIONS="ro,trans=virtio"
+            DCSFS="9p"
+          fi
+      fi
+
       if [ -n "$DCSDEVICE" ]; then
         DCSMP="/mnt/grmlcfg"
       fi
@@ -1451,7 +1610,7 @@ else
 
     # if not specified/present then assume default:
     if [ -z "$DCSDEVICE" ]; then
-      DCSDIR="/live/image"
+      DCSDIR="${LIVECD_PATH}"
     else
       eindent
       einfo "debs, config, scripts are read from $DCSDEVICE." ; eend 0
@@ -1461,7 +1620,7 @@ else
       else
         [ -d $DCSMP ] || mkdir $DCSMP
         umount $DCSMP >>$DEBUG 2>&1 # make sure it is not mounted
-        mount -o ro -t auto $DCSDEVICE  $DCSMP ; RC="$?"
+        mount -o ${MOUNTOPTIONS:-ro} -t ${DCSFS:-auto} $DCSDEVICE  $DCSMP ; RC="$?"
         if [[ $RC == 0 ]]; then
           einfo "Successfully mounted $DCSDEVICE to $DCSMP (readonly)." ; eend 0
         else
@@ -1474,7 +1633,7 @@ else
   fi
 fi
 
-if [ -n "$DCSDIR" -a "$DCSDIR" != "/live/image" ] ; then
+if [ -n "$DCSDIR" -a "$DCSDIR" != "${LIVECD_PATH}" ] ; then
   einfo "Debs, config, scripts (if present) will be read from $DCSDIR." ; eend 0
 elif checkbootparam 'debs' || checkbootparam 'config' || checkbootparam 'scripts'; then
   einfo "Debs, config, scripts will be read from the live image directly." ; eend 0
@@ -1546,7 +1705,7 @@ if checkbootparam 'scripts' || [ "$DCSMP" = "/mnt/grmlcfg" ]; then
        sh -c $SCRIPTS
      elif [ -d "$SCRIPTS" ]; then
        einfo "Bootparameter scripts found. Trying to execute from directory ${SCRIPTS}:"
-       run-parts $SCRIPTS
+       run-parts --regex '.*' $SCRIPTS
      else
        einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
        sh -c $SCRIPTS
@@ -1713,38 +1872,6 @@ fi
 }
 # }}}
 
-# {{{ 915resolution
-config_915resolution(){
-if checkbootparam '915resolution' ; then
- OPTIONS="$(getbootparam '915resolution' 2>>$DEBUG)"
-  if [ -x /usr/sbin/915resolution ]; then
-    CMD=915resolution
-    MODE=""
-    XRESO=""
-    YRESO=""
-    if [ -n "$OPTIONS" ]; then
-      # Extra options
-      MODE="${OPTIONS%%,*}"
-      R="${OPTIONS#*,}"
-      if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
-        OPTIONS="$R"
-        XRESO="${OPTIONS%%,*}"
-        R="${OPTIONS#*,}"
-        if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
-          OPTIONS="$R"
-          YRESO="${OPTIONS%%,*}"
-          R="${OPTIONS#*,}"
-        fi
-      fi
-    fi
-    einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
-    [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
-    eend 0
-  fi
-fi
-}
-# }}}
-
 # {{{ SW-RAID
 config_swraid(){
   [ -n "$INSTALLED" ] && return 0
@@ -1754,6 +1881,7 @@ config_swraid(){
      checkbootparam 'forensic' || checkbootparam 'raid=noautodetect' ; then
      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
   else
+    [ -e /proc/mdstat ] || modprobe md_mod
     if ! [ -x /sbin/mdadm ] ; then
        eerror "mdadm not available, can not execute it." ; eend 1
     else
@@ -1955,7 +2083,7 @@ config_tohd()
 
      if mount -o rw "$TARGET" "$MOUNTDIR" ; then
         einfo "Copyring live system to $TARGET - this might take a while"
-        rsync -a --progress /live/image/live $MOUNTDIR
+        rsync -a --progress ${LIVECD_PATH}/live $MOUNTDIR
         sync
         umount "$MOUNTDIR"
         eend $?
@@ -1970,58 +2098,6 @@ config_tohd()
 }
 # }}}
 
-# {{{ grml2hd: automatic installation
-config_grml2hd(){
-
-if checkbootparam "grml2hd" || checkbootparam "BOOT_IMAGE=grml2hd" ; then
-
-if checkbootparam 'user' ; then
-   NEWUSER=''
-   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
-   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
-fi
-
-if checkbootparam 'filesystem' ; then
-   FILESYSTEM=''
-   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
-   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
-fi
-
-if checkbootparam 'partition' ; then
-   PARTITION=''
-   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
-   # notice: the following checks whether the given partition is available, if not the skip
-   # execution of grml2hd as it might result in data loss...
-   if [ -r $PARTITION ] ; then
-      sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
-   else
-      ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
-   fi
-fi
-
-if checkbootparam 'mbr' ; then
-   BOOT_PARTITION=''
-   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
-   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
-fi
-
-cat>|/usr/bin/grml2hd_noninteractive<<EOF
-#!/bin/sh
-GRML2HD_NONINTERACTIVE='yes' grml2hd
-EOF
-
-chmod 755 /usr/bin/grml2hd_noninteractive
-einfo "Bootoption grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
-if [ -z "$GRML2HD_FAIL" ] ; then
-   screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
-else
-   ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
-fi
-
-fi # if checkbootparam "BOOT_IMAGE=grml2hd ...
-}
-# }}}
-
 # {{{ debootstrap: automatic installation
 config_debootstrap(){
 
@@ -2115,9 +2191,9 @@ fi # checkbootparam "BOOT_IMAGE=debian2hd
 # }}}
 
 config_virtualbox_shared_folders() {
-if [ -r /proc/acpi/battery/BAT0/info ] && grep -q 'OEM info:.*innotek' /proc/acpi/battery/BAT0/info ; then
+if $VIRTUALBOX ; then
   einfo "VirtualBox detected, trying to set up Shared Folders."
-  if ! modprobe -l | grep -q vboxsf.ko ; then
+  if ! modinfo vboxsf &>/dev/null ; then
     ewarn "vboxsf driver not present, not setting up VirtualBox Shared Folders."
     eend 0
   elif ! [ -x /usr/sbin/VBoxService ] ; then
@@ -2135,11 +2211,8 @@ if [ -r /proc/acpi/battery/BAT0/info ] && grep -q 'OEM info:.*innotek' /proc/acp
       chmod 660 /dev/vboxguest
       eend $?
 
-      if [ -n "$CONFIG_FSTAB_USER" ] ; then
-        fstabuser="$CONFIG_FSTAB_USER"
-      else
-        fstabuser=$(getent passwd 1000 | cut -d: -f1)
-      fi
+      config_userfstab
+
       einfo "Adding $fstabuser to group vboxsf."
       adduser grml vboxsf &>/dev/null
       eend $?
@@ -2168,4 +2241,4 @@ fi
 # }}}
 
 ## END OF FILE #################################################################
-# vim:foldmethod=marker expandtab ai ft=zsh shiftwidth=3
+# vim:foldmethod=marker expandtab ai ft=zsh shiftwidth=2